let child_process = require('child_process');

let toolsDir = __dirname;
let srcDir = toolsDir + "/../src";
let nodeModulesDir = toolsDir + "/../node_modules";

let commands = [
	() => child_process.fork(toolsDir + '/embed.js'),
	() => child_process.fork(nodeModulesDir + '/typescript/lib/tsc.js', {'cwd': srcDir}),
	() => child_process.fork(toolsDir + '/purify.js', {'cwd': srcDir})
];

let commandIdx = 0;

function executeCommand(commandIdx) {
	let process = commands[commandIdx]();
	process.on('close', (exitCode) => {
		if(exitCode != 0) throw "Command " + commands[commandIdx] + " failed with code " + exitCode;
		commandIdx += 1;
		if(commandIdx == commands.length) return;
		executeCommand(commandIdx);
	});
}

executeCommand(commandIdx);
